package cz.toho.dao.mapper;

import org.springframework.jdbc.core.RowMapper;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Date;

/**
 * Abstract to-do row mapper
 * <p>
 * Created by tomasholicky
 */

public abstract class AbstractTodoRowMapper<T> implements RowMapper<T> {
    /**
     * Method, that get date time from result set, for given column
     *
     * @param rs     result set
     * @param column colum
     * @return {@link Date}
     * @throws SQLException
     */
    Date getDateTime(final ResultSet rs, final String column) throws SQLException {
        final Timestamp resValue = rs.getTimestamp(column);

        if (resValue == null) {
            return null;
        }

        return new Date(resValue.getTime());
    }
}
