package cz.toho.dao.mapper;

import cz.toho.model.Note;
import org.springframework.stereotype.Component;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Row mapper for {@link Note}
 * <p>
 * Created by tomasholicky
 */
@Component
public class NoteMapper extends AbstractTodoRowMapper<Note> {
    @Override
    public Note mapRow(final ResultSet rs, final int rowNum) throws SQLException {
        Note note = new Note();
        note.setIdNote(rs.getLong("ID_NOTE"));
        note.setIdTask(rs.getLong("ID_TASK"));
        note.setEmail(rs.getString("EMAIL"));
        note.setNote(rs.getString("NOTE"));
        note.setInsertDate(this.getDateTime(rs, "INSERT_DATE"));
        return note;
    }
}
