package cz.toho.dao.mapper;

import cz.toho.model.TaskFileInfo;
import org.springframework.stereotype.Component;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Row mapper for {@link TaskFileInfo}
 * <p>
 * Created by tomasholicky
 */
@Component
public class TaskFileInfoMapper extends AbstractTodoRowMapper<TaskFileInfo> {
    @Override
    public TaskFileInfo mapRow(final ResultSet rs, final int i) throws SQLException {
        TaskFileInfo taskFileInfo = new TaskFileInfo();
        taskFileInfo.setEmail(rs.getString("EMAIL"));
        taskFileInfo.setFileName(rs.getString("FILE_NAME"));
        taskFileInfo.setIdFile(rs.getLong("ID_FILE"));
        taskFileInfo.setIdTask(rs.getLong("ID_TASK"));
        taskFileInfo.setInsertDate(this.getDateTime(rs, "INSERT_DATE"));
        return taskFileInfo;
    }
}
