package cz.toho.dao.mapper;

import cz.toho.model.TaskFile;
import org.springframework.stereotype.Component;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Row mapper for {@link TaskFile}
 * <p>
 * Created by tomasholicky
 */

@Component
public class TaskFileMapper extends AbstractTodoRowMapper<TaskFile> {
    @Override
    public TaskFile mapRow(final ResultSet rs, final int i) throws SQLException {
        TaskFile taskFile = new TaskFile();
        taskFile.setFileName(rs.getString("FILE_NAME"));
        taskFile.setFile(rs.getBlob("FILE_ITEM"));
        taskFile.setContentType(rs.getString("CONTENT_TYPE"));
        return taskFile;
    }
}
