package cz.toho.dao.mapper;

import cz.toho.model.Task;
import cz.toho.model.TaskStatusEnum;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Component;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Row mapper for {@link Task}
 * <p>
 * Created by tomasholicky
 */
@Component
public class TaskMapper implements RowMapper<Task> {
    @Override
    public Task mapRow(final ResultSet rs, final int rowNum) throws SQLException {
        Task task = new Task();
        task.setIdTask(rs.getLong("id_task"));
        task.setName(rs.getString("name"));
        task.setDescription(rs.getString("description"));
        task.setUrgent(rs.getBoolean("urgent"));
        task.setTaskStatus(TaskStatusEnum.valueOf(rs.getString("status")));
        return task;
    }
}
