package cz.toho.dao.mapper;

import cz.toho.model.User;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Component;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Row mapper for {@link User}
 * <p>
 * Created by tomasholicky
 */
@Component
public class UserMapper implements RowMapper<User> {

    @Override
    public User mapRow(final ResultSet rs, final int i) throws SQLException {
        User user = new User();
        user.setUserId(rs.getLong("id_user"));
        user.setPassword(rs.getString("password"));
        user.setUserName(rs.getString("email"));
        user.setAccountNonExpired(rs.getBoolean("account_non_expired"));
        user.setAccountNonLocked(rs.getBoolean("account_non_locked"));
        user.setCredentialsNonExpired(rs.getBoolean("credentials_non_expired"));
        user.setEnabled(rs.getBoolean("enabled"));
        return user;
    }
}
