package cz.toho.security;

import cz.toho.dao.UserDao;
import cz.toho.exception.TodoListDaoException;
import cz.toho.model.Role;
import cz.toho.model.User;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Custom user detal service
 * <p>
 * Created by tomasholicky
 */
@Service
public class CustomUserDetailService implements UserDetailsService {
    /**
     * user dao
     */
    @Autowired
    UserDao userDao;

    @Override
    public UserDetails loadUserByUsername(String s) throws UsernameNotFoundException {
        User user = null;
        try {
            // load user
            user = userDao.getUser(s);

            if (user == null) {
                return null;
            }

            // add user role
            List<Role> roleList = userDao.getUserRoles(user.getUserId());
            user.setAuthorities(roleList);
        } catch (TodoListDaoException e) {
            throw new UsernameNotFoundException("Error while loading user", e);
        }

        return user;
    }
}
