package cz.toho.service;

import cz.toho.exception.TodoListException;
import cz.toho.model.Note;

import java.util.List;

/**
 * Note service
 * <p>
 * Created by tomasholicky
 */

public interface NoteService {
    /**
     * Create note for given user and task
     *
     * @param currentUserName current user name
     * @param idTask          id task
     * @param note            note
     * @return id
     * @throws TodoListException
     */
    long createNote(final String currentUserName, final long idTask, final String note) throws TodoListException;

    /**
     * Load all notes by given user and task
     *
     * @param userName user name
     * @param idTask   id task
     * @return list of {@link Note}
     * @throws TodoListException
     */
    List<Note> loadNotesByTask(final String userName, final Long idTask) throws TodoListException;
}
