package cz.toho.service;

import cz.toho.exception.TodoListException;

/**
 * User service
 * <p>
 * Created by tomasholicky
 */
public interface UserService {
    /**
     * Create user
     *
     * @param userName user name
     * @param password password
     * @return id of created user
     * @throws TodoListException
     */
    long createUser(final String userName, final String password) throws TodoListException;

    /**
     * Check, that user exist
     *
     * @param userName user name
     * @return when user exist, then true , otherwise false
     * @throws TodoListException
     */
    boolean existsUser(final String userName) throws TodoListException;

    /**
     * Check right for given task
     *
     * @param userName user name
     * @param idTask   id of task
     * @return when user has right, then tru, otherwise false
     * @throws TodoListException
     */
    boolean checkRightForGivenTask(final String userName, final Long idTask) throws TodoListException;
}
