/**
 * Created by tomasholicky
 */
(function () {
    'use strict';

    angular.module('cz.toho.auth.directives', [])
        .directive('authUserName', function (authService) {
            return {
                scope: {},
                restrict: 'E',
                link: function (scope) {
                    scope.auth = authService;
                },
                template: '{{auth.info.user.username}}'
            };
        })

        .directive('authIsAuthenticated', function (authService, EVENTS) {
            return {
                restrict: 'A',
                link: function (scope, element) {
                    element.toggleClass('ng-hide', !authService.isAuthenticated());

                    scope.$on(EVENTS.changedState, function () {
                        element.toggleClass('ng-hide', !authService.isAuthenticated());
                    });
                }
            };
        })

        .directive('authIsNotAuthenticated', function (authService, EVENTS) {
            return {
                scope: {},
                restrict: 'A',
                link: function (scope, element) {
                    element.toggleClass('ng-hide', authService.isAuthenticated());

                    scope.$on(EVENTS.changedState, function () {
                        element.toggleClass('ng-hide', authService.isAuthenticated());
                    });
                }
            };
        })

        .directive('authHasRole', function (authService, EVENTS) {
            return {
                scope: {
                    role: '@authHasRole'
                },
                restrict: 'A',
                link: function (scope, element) {
                    scope.actualize = function () {
                        var hasRole = authService.hasRole(scope.role);
                        element.toggleClass('ng-hide', !hasRole);
                    };

                    scope.$on(EVENTS.changedState, function () {
                        scope.actualize();
                    });

                    scope.auth = authService;
                    scope.actualize();
                }
            };
        })

        .directive('profile', function (authService) {
            return {
                scope: {},
                restrict: 'E',
                link: function (scope) {
                    scope.logout = function () {
                        authService.logout();
                    };
                },
                templateUrl: 'common/directive/template/profile.html'
            };
        });

})();