/**
 * Created by tomasholicky
 */
(function () {
    'use strict';

    angular.module('cz.toho.common.directives', [])
        .directive('taskPanel', function (ApiTask, $rootScope, TASK_STATES, $state, Notification) {
            return {
                controller: function ($scope) {

                    $scope.TASK_STATES = TASK_STATES;

                    $scope.deleteTask = function (idTask) {
                        ApiTask.TaskId.delete({id: idTask}, function () {
                            $scope.actionByCurrentState();
                            Notification.error('<i class="fa fa-trash-o"></i> Úkol byl smazán.');
                        });
                    };

                    $scope.doneTask = function (task) {
                        ApiTask.UpdateTaskStatus.update({status: TASK_STATES.done}, task, function () {
                            $scope.actionByCurrentState();
                            Notification.success('<i class="fa fa-check"></i> Úkol úspěšně dokončen.');
                        });
                    };

                    $scope.addToList = function (task) {
                        ApiTask.UpdateTaskStatus.update({status: TASK_STATES.todo}, task, function () {
                            $scope.actionByCurrentState();
                            Notification.success('<i class="fa fa-plus"></i> Úkol byl vrácen zpět do rozpracovaných.');
                        });
                    };

                    $scope.markAsUrgent = function (task) {
                        ApiTask.MarkUrgentTask.update({urgent: !task.urgent}, task, function () {
                            if ($state.current.name == 'user.tasks') {
                                $rootScope.$broadcast('cz.toho.task:reloadTasks');
                            } else {
                                $rootScope.$broadcast('cz.toho.task:reloadDetailTask');
                            }
                            Notification.warning('<i class="fa fa-check"></i> Úkol byl označen jako urgentní.');
                        });
                    };

                    $scope.shareTask = function (task) {
                        ApiTask.ShareTask.update({share: $scope.shareEmail}, task, function (success) {
                            var shareNotification = '<i class="fa fa-share-alt"></i> Úkol byl sdílen s uživatelem ' + $scope.shareEmail;
                            Notification.primary(shareNotification);
                        }, function (error) {
                        });
                    };

                    $scope.actionByCurrentState = function () {
                        if ($state.current.name == 'user.tasks') {
                            $rootScope.$broadcast('cz.toho.task:reloadTasks');
                        } else {
                            $state.go('user.tasks');
                        }
                    };
                },
                restrict: 'E',
                scope: {task: '=', state: '='},
                templateUrl: 'common/directive/template/taskPanel.html'

            };
        }).directive('notePanel', function () {
        return {
            controller: function ($scope) {
            },
            restrict: 'E',
            scope: {note: '='},
            templateUrl: 'common/directive/template/notePanel.html'
        };
    });
})();