/**
 * Created by tomasholicky
 */
(function () {
    'use strict';

    var taskResourceFactory = angular.module('cz.toho.taskResourceFactory', ['ngResource', 'cz.toho.auth']);

    taskResourceFactory.factory('ApiTask', ['$resource', 'API_URI', function ($resource, API_URI) {
        return {
            Tasks: $resource(API_URI + '/tasks', {}, {
                query: {
                    method: 'GET',
                    isArray: true
                },
                save: {
                    method: 'POST'
                }
            }),
            TaskByStatus: $resource(API_URI + '/tasks?status=:status', {}, {
                query: {
                    method: 'GET',
                    params: {
                        status: 'status'
                    },
                    isArray: true
                }
            }),
            UrgentTasks: $resource(API_URI + '/tasks/urgent', {}, {
                query: {
                    method: 'GET',
                    isArray: true
                }
            }),
            TaskId: $resource(API_URI + '/tasks/:id', {}, {
                delete: {
                    method: 'DELETE',
                    params: {
                        id: 'idTask'
                    }
                },
                get: {
                    method: 'GET',
                    isArray: false,
                    params: {
                        id: 'id'
                    }
                }
            }),
            UpdateTaskStatus: $resource(API_URI + '/tasks/:id?status=:status', {id: "@idTask"}, {
                update: {
                    method: 'PUT',
                    params: {
                        status: 'status'
                    }
                }
            }),
            MarkUrgentTask: $resource(API_URI + '/tasks/:id?urgent=:urgent', {id: "@idTask"}, {
                update: {
                    method: 'PUT',
                    params: {
                        urgent: 'urgent'
                    }
                }
            }),
            ShareTask: $resource(API_URI + '/tasks/:id?share=:share', {id: "@idTask"}, {
                update: {
                    method: 'PUT',
                    params: {
                        share: 'share'
                    }
                }
            }),
            Notes: $resource(API_URI + '/tasks/:id/notes', {id: "@idTask"}, {
                query: {
                    method: 'GET',
                    isArray: true,
                    params: {
                        id: 'id'
                    }
                },
                save: {
                    method: 'POST'
                }
            }),
            Files: $resource(API_URI + '/tasks/:id/files', {id: "@idTask"}, {
                query: {
                    method: 'GET',
                    isArray: true,
                    params: {
                        id: 'id'
                    }
                }
            }),
            File: $resource(API_URI + '/tasks/:idTask/files/:idFile', {}, {
                delete: {
                    method: 'DELETE'
                },
                params: {
                    idTask: 'idTask',
                    idFile: 'idFile'
                }
            })
        };
    }]);
})();