/**
 * Created by tomasholicky
 */
(function () {
    'use strict';

    angular.module('cz.toho.registration', []).controller('registrationController', ['$scope', 'authService', 'RegisterNewUser', function ($scope, authService, RegisterNewUser) {
        this.credentials = {};

        this.register = function (registrationForm) {
            if (registrationForm.email.$valid || registrationForm.password.$valid) {
                RegisterNewUser.save(this.credentials, function (success) {
                    authService.login(success.username, success.password);
                }, function (error) {
                    if (error.status == 409) {
                        $scope.$broadcast('cz.toho.auth:userExists', {username: error.data});
                    }
                });
            }
        };

        $scope.$on('cz.toho.auth:userExists', function (event, args) {
            this.existsUser = args.username;
        }.bind(this));

    }]);
})();