/**
 * Created by tomasholicky
 */
(function () {
    'use strict';

    var taskList = angular.module('cz.toho.task', ['cz.toho.task.detail']);

    taskList.controller('taskListController', ['$scope', 'TASK_STATES', 'ApiTask', function ($scope, TASK_STATES, ApiTask) {
        this.TASK_STATES = TASK_STATES;

        $scope.loadTasksByStatus = function (taskStatus) {
            $scope.clearTasks();
            var data = ApiTask.TaskByStatus.query({status: taskStatus});
            data.$promise.then(function (response) {
                transformResponseToArrayOfTask(response);
            });
            $scope.setActiveState(taskStatus);
        };

        $scope.loadUrgentTasks = function () {
            $scope.clearTasks();
            var data = ApiTask.UrgentTasks.query();
            data.$promise.then(function (response) {
                transformResponseToArrayOfTask(response);
            });
            $scope.setActiveState(TASK_STATES.urgent);
        };

        $scope.$on('cz.toho.task:reloadTasks', function () {
            $scope.reloadTasks();
        });

        $scope.reloadTasks = function () {
            $scope.clearTasks();
            if ($scope.menuState == TASK_STATES.urgent) {
                $scope.loadUrgentTasks();
            } else {
                $scope.loadTasksByStatus($scope.menuState);
            }
        };

        $scope.clearTasks = function () {
            $scope.tasks = [];
        };

        $scope.setActiveState = function (taskStatus) {
            $scope.menuState = taskStatus;
        };

        $scope.clearTasks();
        $scope.loadTasksByStatus(TASK_STATES.todo);

        // utility methods
        var transformResponseToArrayOfTask = function (response) {
            var arrayLength = response.length;
            if (arrayLength === 0) {
                $scope.tasks = [];
            } else {
                for (var i = 0; i < arrayLength; i++) {
                    $scope.tasks.push(
                        response[i]
                    );
                }
            }
        };
    }]);
})();
